#make_COM#
ORG 00h

start:
     push cs
     pop ds

     mov si,OFFSET Welcome
     call PrintStr
     mov si,OFFSET RooPrompt
     call PrintStr
     
     xor ax,ax
CmdLoop:
     mov ah,00h
     int 16h
     cmp al,0Dh
     je Cmd
AnyKey:
     cmp CursorPos,99
     je CmdLoop
     cmp al,08h
     je Backspace
     call AddnShow
     jmp CmdLoop
BackSpace:
     cmp CursorPos,0
     je CmdLoop
     dec CursorPos
     mov ah,0Eh
     int 10h
     mov ax,0E20h
     int 10h
     mov ax,0E08h
     int 10h
     jmp CmdLoop
Cmd:
     mov ax,0E0Dh
     int 10h
     mov ax,0E0Ah
     int 10h
   
     mov CursorPos,0   

     mov si,OFFSET CmdList
     xor cx,cx
     xor ah,ah
     xor bx,bx
FindCmd:
     mov di,OFFSET CmdBuffer
     lodsb
     cmp al,0
     je BadCmd
     mov cl,al
     push si
     repe cmpsb
     je FindAddr
     pop si
     add si,ax
     inc bl
     cmp bl,6
     je BadCmd
     jmp FindCmd
FindAddr:
     pop si
     mov si,di
     lodsb
     cmp al,0
     je GoodCmd
     jmp BadCmd
GoodCmd:
     mov CursorPos,0
     xor ax,ax
     mov al,bl
     mov cl,2
     mul cl
     mov bx,OFFSET CmdAddr
     add bx,ax
     mov si,[bx]
     jmp si     
BadCmd:
     lea si,BadCommand
     call PrintStr
     call ClearBuffer
     jmp CmdLoop
AddnShow:
     xor bx,bx
     mov bl,CursorPos
     mov byte ptr[CmdBuffer+bx],al
     mov ah,0Eh
     int 10h     
     inc CursorPos
     ret
Hello:
     lea si,HelloStr
     call PrintStr
     call ClearBuffer
     jmp CmdLoop  
ShowIntro:
     lea si,Intro
     call PrintStr
     call ClearBuffer
     jmp CmdLoop
Clear:
     mov ax,0003h
     int 10h
     call ClearBuffer
     jmp CmdLoop

Help:
     mov si,OFFSET HelpText
     call PrintStr
     call ClearBuffer
     jmp CmdLoop
Reboot:
     jmp 0FFFFh:00h

PrintStr:
     mov ah,0eh
     stringloop:
     lodsb
     cmp al,00h
     je endstring
     int 10h
     jmp stringloop
endstring:
     ret
      
ClearBuffer:
     lea si,RooPrompt
     call PrintStr
     
     lea di,CmdBuffer
     mov cx,99
     mov al,0
     rep stosb
     ret
ShutDown:
     mov si,OFFSET PowerOff
     call PrintStr
     hlt

Welcome       db "Ok",13,10
              db "Welcome to RooOs",13,10
Intro	      db "     _______     _________    _________    ",13,10
	      db "    !!          ",13,10
	      db "    !!^^^!!     ^^^^^    !^^^^^!   ",13,10
	      db "    !!  !!     ____  !____! ",13,10
	      db "    !!___!!     @   @     !@   @!    ",13,10
	      db "    !!        !       !  !  !    ",13,10
	      db "    !!          \_/      ! \_/ !    ",13,10
	      db "    !!                   !     !    ",13,10
	      db "    !!         _____     !_____!    ",13,10
	      db "    !!                ",13,10
	      db "                   __/\                    ",13,10
	      db "                  /__ @|                   ",13,10
	      db "                     | ! _____             ",13,10
	      db "                  ___/  \\___ \            ",13,10
	      db "                 /__  _  \   \ \           ",13,10
	      db "                   / / \  !  / /           ",13,10
	      db "                ___\ \  \ \_/ /            ",13,10
	      db "               /_______/\____/             ",13,10
	      db "                                           ",13,10
	      db "Type help for help on commands",13,10
	      db "Developed by",13,10
	      db "Thomas Antony",13,10,0
HelpText      db "Thank u for using RooOs!!!",13,10,13,10
	      db "This is a list of supported commands",13,10
              db "Type the command at the prompt and press <Enter>",13,10,13,10
              db "Commands",13,10,13,10
              db "cls          : Clears the screen",13,10
              db "help	        : Shows this help text",13,10
              db "hello        : Says Hello",13,10
              db "intro	       : Shows the intro graphics",13,10
              db "reboot       : Restarts the computer",13,10
              db "shutdown     : Shut downs the computer",13,10,0
PowerOff      db "It is now safe to turn off the computer",13,10,0
RooPrompt     db 13,10,"Roo->:",0
CmdList	      db 6,"reboot",5,"hello",5,"intro",8,"shutdown",4,"help",3,"cls",0
CmdAddr	      dw OFFSET Reboot,OFFSET Hello,OFFSET ShowIntro,OFFSET ShutDown,OFFSET Help,OFFSET Clear
HelloStr      db "Hello to you!!",0
BadCommand    db "Unknown command entered",0
CursorPos     db 0
CmdBuffer     db 100 dup(0)